/// <reference types="regular-table" />
import { IContentRow } from "./content";
import { ContentsModel } from "./model";
declare const RegularTableElement: typeof import("regular-table").RegularTableElement;
export declare class TreeFinderGridElement<T extends IContentRow> extends RegularTableElement {
    init(model: ContentsModel<T>, options?: Partial<TreeFinderGridElement.IOptions<T>>): Promise<void>;
    dataListener(start_col: number, start_row: number, end_col: number, end_row: number): Promise<{
        num_columns: number;
        num_rows: number;
        column_headers: (keyof T)[][];
        row_headers: (ChildNode | null)[][];
        data: (string | T[keyof T])[][];
    }>;
    columnHeaderStyleListener(): void;
    rowStyleListener(): void;
    onSortClick(event: MouseEvent): void;
    onTreeClick(event: MouseEvent): void;
    onRowDoubleClick(event: MouseEvent): void;
    protected options: TreeFinderGridElement.IOptions<T>;
    protected model: ContentsModel<T>;
    private _initializedListeners;
}
export declare namespace TreeFinderGridElement {
    interface IOptions<T extends IContentRow> {
        /**
         * if true, redraw the tree-finder element on window resize events
         */
        doWindowReize: boolean;
    }
}
export {};
