import { Content, IContentRow } from "./content";
import { SortStates } from "./sort";
export declare class ContentsModel<T extends IContentRow> {
    constructor(root?: T, options?: Partial<ContentsModel.IOptions<T>>);
    setRoot(root: T): void;
    initColumns(): void;
    collapse(rix: number): Promise<void>;
    expand(rix: number): Promise<void>;
    sort(props?: {
        col?: keyof T;
        multisort?: boolean;
    }): void;
    get columns(): (keyof T)[];
    get contents(): Content<T>[];
    get pathDepth(): number;
    get sortStates(): SortStates<T>;
    get root(): Content<T>;
    get options(): Partial<ContentsModel.IOptions<T>>;
    set options(options: Partial<ContentsModel.IOptions<T>>);
    get ixByColumn(): { [k in keyof T]: number; };
    protected _columns: (keyof T)[];
    protected _contents: Content<T>[];
    protected _root: Content<T>;
    protected _sortStates: SortStates<T>;
    protected _options: ContentsModel.IOptions<T>;
    private _ixByColumn;
}
export declare namespace ContentsModel {
    interface IOptions<T extends IContentRow> {
        /**
         * optionally specify the visible columns, and the order they appear in
         */
        columnNames: (keyof T)[];
        /**
         * if true, always (re)fetch children when opening a dir
         */
        doRefetch: boolean;
    }
}
